## jami-20251003.0.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.21..3.31)
if(POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif()
if(POLICY CMP0135)
  cmake_policy(SET CMP0135 NEW)
endif()
if(NOT CMAKE_VERSION VERSION_LESS 3.30 AND NOT POLICY CMP0167)
  cmake_policy(SET CMP0167 OLD)
endif()

set (opendht_VERSION_MAJOR 3)
set (opendht_VERSION_MINOR 5.4)
set (opendht_VERSION ${opendht_VERSION_MAJOR}.${opendht_VERSION_MINOR})
set (PACKAGE_VERSION ${opendht_VERSION})
set (VERSION "${opendht_VERSION}")
project (opendht
    VERSION ${opendht_VERSION}
    DESCRIPTION "OpenDHT: A lightweight C++17 Distributed Hash Table library."
    HOMEPAGE_URL "https://opendht.net/"
)

include(CMakePackageConfigHelpers)
include(CMakeDependentOption)
include(CheckIncludeFileCXX)
set(POSSIBLE_PKGCONFIG OFF)
if(NOT MSVC)
    include(FindPkgConfig)
    set(POSSIBLE_PKGCONFIG ON)
endif()
include(cmake/CheckAtomic.cmake)
include(CTest)

# Options
option (BUILD_SHARED_LIBS "Build shared library" ON)
option (OPENDHT_USE_PKGCONFIG "Use pkg-config to find installed libraries where possible" ${POSSIBLE_PKGCONFIG})
option (OPENDHT_PYTHON "Build Python bindings" OFF)
option (OPENDHT_TOOLS "Build DHT tools" ON)
option (OPENDHT_EXAMPLES "Build DHT examples" OFF)
option (OPENDHT_SYSTEMD "Install systemd module" OFF)
option (OPENDHT_SYSTEMD_UNIT_FILE_LOCATION "Where to install systemd unit file")
option (OPENDHT_SANITIZE "Build with address sanitizer and stack protector" OFF)
option (OPENDHT_PROXY_SERVER "Enable DHT proxy server, use Restinio and jsoncpp" OFF)
option (OPENDHT_PUSH_NOTIFICATIONS "Enable push notifications support" OFF)
option (OPENDHT_PROXY_SERVER_IDENTITY "Allow clients to use the node identity" OFF)
option (OPENDHT_PROXY_CLIENT "Enable DHT proxy client, use Restinio and jsoncpp" OFF)
option (OPENDHT_PROXY_OPENSSL "Build DHT proxy with OpenSSL" ON)
CMAKE_DEPENDENT_OPTION(OPENDHT_HTTP "Build embedded http(s) client" OFF "NOT OPENDHT_PROXY_SERVER;NOT OPENDHT_PROXY_CLIENT" ON)
option (OPENDHT_PEER_DISCOVERY "Enable multicast peer discovery" ON)
option (OPENDHT_IO_URING "Use io_uring if available on the system (Linux only)" OFF)
option (OPENDHT_INDEX "Build DHT indexing feature" OFF)
option (OPENDHT_TESTS_NETWORK "Enable unit tests that require network access" ON)
option (OPENDHT_C "Build C bindings" OFF)
option (OPENDHT_CPACK "Add CPack support" OFF)
option (OPENDHT_DOWNLOAD_DEPS "Fetch automatically the missing dependency libraries from the network" ON)

find_package(Doxygen QUIET)
if (DOXYGEN_FOUND)
    option (OPENDHT_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})
endif ()
# Build flags
set (CMAKE_CXX_STANDARD 17)
set (CMAKE_CXX_STANDARD_REQUIRED on)
if(MSVC AND NOT BUILD_SHARED_LIBS AND NOT DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

if (OPENDHT_C)
    set (CMAKE_C_STANDARD 11)
    set (CMAKE_C_STANDARD_REQUIRED ON)
    if (MSVC)
        set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /experimental:c11atomics")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /experimental:c11atomics")
    endif()
endif()

if (NOT HAVE_CXX_ATOMICS_WITHOUT_LIB
        # For ARM EABI (armel), little-endian MIPS (mipsel), etc.
        OR NOT HAVE_CXX_ATOMICS64_WITHOUT_LIB)
    link_libraries (atomic)
endif ()

if(WIN32)
    include(cmake/WindowsUtils.cmake)
    get_WIN32_WINNT(WINNT_VERSION)
    message(STATUS "Windows NT version detection: ${WINNT_VERSION}")
    # Prevents MinGW from problems linking Windows networking and IPC functions on Windows 10/11
    # if _WIN32_WINNT is not defined correctly
    if(NOT MSVC)
        add_definitions(-D_WIN32_WINNT=${WINNT_VERSION} -DWINVER=${WINNT_VERSION})
    endif()
    set(CMAKE_DEBUG_POSTFIX "")
endif()

# Dependencies
if(OPENDHT_DOWNLOAD_DEPS)
    message(STATUS "Dependency downloader fallback activated")
    include(FetchContent)
    set(FETCHCONTENT_QUIET FALSE)
endif()

if (WIN32)
    set(MAP_IMPORTED_CONFIG_RELWITHDEBINFO RELEASE) # MSVC CMake cache workaround
endif ()

list (APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
if (NOT MSVC)
    # Initialize pkg-config substitution variables for llhttp before any detection
    set(http_lib "")
    set(llhttp_lib "")
    # Generalized UNIX/MSYS2 build pipeline
    set (THREADS_PREFER_PTHREAD_FLAG TRUE)
    find_package (Threads)
    if (OPENDHT_USE_PKGCONFIG)
        find_package (PkgConfig REQUIRED)
        # GNUTLS
        pkg_search_module (GnuTLS REQUIRED IMPORTED_TARGET gnutls)
        # libnettle
        pkg_search_module (Nettle REQUIRED IMPORTED_TARGET nettle)
        # libargon2
        pkg_search_module (argon2 REQUIRED IMPORTED_TARGET libargon2)
        set(argon2_lib ", libargon2")
        # jsoncpp
        pkg_search_module (Jsoncpp IMPORTED_TARGET jsoncpp)
        if(Jsoncpp_FOUND)
            set(JSONCPP_LIBRARIES PkgConfig::Jsoncpp)
            set(JSONCPP_INCLUDE_DIRS ${Jsoncpp_INCLUDE_DIRS})
            set(JSONCPP_FOUND ${Jsoncpp_FOUND})
        endif()
        #  libfmt 
        pkg_search_module (fmt REQUIRED IMPORTED_TARGET fmt)
        # libreadline
        if (OPENDHT_TOOLS AND NOT APPLE)   
            pkg_search_module(readline REQUIRED IMPORTED_TARGET readline)
            message(STATUS "libreadline: version ${readline_VERSION}")
            set(READLINE_VERSION ${readline_VERSION})
            if(READLINE_VERSION VERSION_LESS 6)
                message(SEND_ERROR "libreadline: required version 6.0 or later")
            endif()
            set(READLINE_LIBRARIES ${readline_LIBRARIES})
        endif ()
        # ASIO
        if (OPENDHT_HTTP OR OPENDHT_PEER_DISCOVERY)
            pkg_search_module(asio IMPORTED_TARGET asio)
            if (NOT asio_FOUND)
                find_path(ASIO_INCLUDE_DIR asio.hpp REQUIRED)
            endif()
            message(STATUS "Found ASIO: ${ASIO_INCLUDE_DIR}")
        endif ()
        # llhttp
        if (OPENDHT_HTTP)
            pkg_search_module(LLHTTP IMPORTED_TARGET llhttp libllhttp)
            if (LLHTTP_FOUND)
                message(STATUS "Found llhttp: ${LLHTTP_FOUND} ${LLHTTP_INCLUDE_DIR} (module: ${LLHTTP_MODULE_NAME})")
                set(llhttp_target PkgConfig::LLHTTP)
                set(llhttp_lib ", ${LLHTTP_MODULE_NAME}")
            else()
                message(STATUS "llhttp not found with pkgconfig")
            endif()
        else ()
            set(OPENDHT_PROXY_OPENSSL OFF)
        endif ()
        if (OPENDHT_PROXY_OPENSSL)
            pkg_search_module(OPENSSL REQUIRED IMPORTED_TARGET openssl)
            if (OPENSSL_FOUND)
                message(STATUS "Found OpenSSL ${OPENSSL_VERSION} ${OPENSSL_INCLUDE_DIRS}")
                set(openssl_lib ", openssl")
            else ()
                message(SEND_ERROR "OpenSSL is required for DHT proxy as specified")
            endif()
        endif()
    else ()
        find_package(GnuTLS REQUIRED)
        include_directories(${GNUTLS_INCLUDE_DIR})
        # jsoncpp
        find_package(jsoncpp CONFIG REQUIRED)
        set(JSONCPP_FOUND TRUE)
        # libfmt
        find_package(fmt CONFIG REQUIRED)
        # libargon2
        find_path(ARGON2_INCLUDE_DIR argon2.h REQUIRED)
        set(argon2_lib ", libargon2")
        # libreadline
        if (OPENDHT_TOOLS)
            find_package (Readline 6 REQUIRED)
        endif ()
        # ASIO
        if (OPENDHT_HTTP OR OPENDHT_PEER_DISCOVERY)
            find_path(ASIO_INCLUDE_DIR asio.hpp REQUIRED)
            message(STATUS "Found ASIO ${ASIO_INCLUDE_DIR}")
        else()
            message(STATUS "ASIO not required")
        endif ()
        # llhttp
        if (OPENDHT_HTTP)
            find_package(llhttp CONFIG REQUIRED)
            set(llhttp_target llhttp::llhttp_static)
            set(http_lib "-lllhttp")
            if (OPENDHT_PROXY_OPENSSL)
                find_package(openssl REQUIRED)
            endif()
        else ()
            set(OPENDHT_PROXY_OPENSSL OFF)
        endif ()
    endif ()
    # File-based searches
    # msgpack
    check_include_file_cxx(msgpack.hpp HAVE_MSGPACKCXX)
    if (NOT HAVE_MSGPACKCXX)
        find_package(msgpack CONFIG NAMES msgpack-cxx)
        if (NOT msgpack_FOUND)
            find_package(msgpack CONFIG NAMES msgpack msgpackc-cxx)
            if (msgpack_FOUND)
                set(MSGPACK_TARGET "msgpackc-cxx")
            else()
                if(OPENDHT_DOWNLOAD_DEPS)
                    # Workaround for msgpack-cxx
                    FetchContent_Declare(msgpack-c
                        GIT_REPOSITORY "https://github.com/msgpack/msgpack-c.git"
                        GIT_TAG        "cpp-7.0.0"
                        FIND_PACKAGE_ARGS NAMES msgpack-c 
                    )
                    set(MSGPACK_USE_BOOST OFF CACHE INTERNAL "Workaround for Boost")
                    FetchContent_MakeAvailable(msgpack-c)
                    find_package(msgpack-cxx CONFIG REQUIRED)
                    set(MSGPACK_TARGET msgpack-cxx)
                else()
                    message(SEND_ERROR "msgpack not found and the fallback downloader is not set! Please install msgpack or use OPENDHT_DOWNLOAD_DEPS option")
                endif()
            endif ()
        else()
            set(MSGPACK_TARGET "msgpack-cxx")
        endif()
    endif()
    # llhttp
    if (OPENDHT_HTTP AND NOT LLHTTP_FOUND)
        find_path(LLHTTP_INCLUDE_DIR llhttp.h)
        find_library(LLHTTP_LIBRARY NAMES llhttp libllhttp)
        if (LLHTTP_INCLUDE_DIR AND LLHTTP_LIBRARY)
            message(STATUS "Found llhttp ${LLHTTP_INCLUDE_DIR} ${LLHTTP_LIBRARY}")
            add_library(llhttp_static STATIC IMPORTED)
            set_target_properties(llhttp_static PROPERTIES
                IMPORTED_LOCATION ${LLHTTP_LIBRARY}
                INTERFACE_INCLUDE_DIRECTORIES ${LLHTTP_INCLUDE_DIR}
            )
            set(llhttp_target llhttp_static)
            if (NOT llhttp_lib)
                set(http_lib "-lllhttp")
            endif()
        elseif (OPENDHT_DOWNLOAD_DEPS)
            message(STATUS "Fallback mode specified, downloading llhttp")
            FetchContent_Declare(llhttp-local REQUIRED
                URL "https://github.com/nodejs/llhttp/archive/refs/tags/release/v9.2.1.tar.gz"
            )
            if (BUILD_SHARED_LIBS)
                set(BUILD_SHARED_LIBS ON CACHE INTERNAL "")
            else()
                set(BUILD_SHARED_LIBS OFF CACHE INTERNAL "")
                set(BUILD_STATIC_LIBS ON CACHE INTERNAL "")
            endif()
            FetchContent_MakeAvailable(llhttp-local)
            include_directories(${llhttp-local_SOURCE_DIR}/include)
            link_directories(${llhttp-local_BINARY_DIR}) # MacOS library search workaround
            if (BUILD_SHARED_LIBS)
                set(llhttp_target llhttp_shared)
            else()
                set(llhttp_target llhttp_static)
            endif()
            if (NOT llhttp_lib)
                set(http_lib "-lllhttp")
            endif()
        else()
            message(SEND_ERROR "llhttp not found and fallback downloader disabled. Install llhttp or use OPENDHT_DOWNLOAD_DEPS option")
        endif ()
    endif ()
    # restinio: does not provide pkg-config PC file
    if(OPENDHT_HTTP)
        find_package(Restinio REQUIRED)
        set(restinio_target "")
    endif()
    # System-specific pipeline setup
    if(APPLE)
        if (OPENDHT_TOOLS)
            find_package (Readline 6 REQUIRED)
        endif ()
    endif()
else () # MSVC
    include_directories(src/compat/msvc)
    include_directories(src/compat/win32)
    
    find_package(unofficial-argon2 CONFIG REQUIRED)
    include_directories(${ARGON2_INCLUDEDIR})
    set(argon2_lib ", libargon2")

    find_package(GnuTLS REQUIRED)
    include_directories(${GNUTLS_INCLUDE_DIR})
    
    find_package(msgpack-cxx CONFIG REQUIRED)
    get_target_property(MSGPACK_INCLUDEDIR msgpack-cxx INTERFACE_INCLUDE_DIRECTORIES)
    include_directories(${MSGPACK_INCLUDEDIR})

=== daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(jami-core
    VERSION 16.0.0
    LANGUAGES C CXX)
set(PACKAGE_NAME "Jami Daemon")
set (CMAKE_CXX_STANDARD 17)

set(PROJECT_LABEL "libjami")

################################################################################
# Build options
################################################################################
option(JAMI_NATPMP "Build with NAT-PMP" ON)
option(JAMI_PUPNP "Build with PUPNP" ON)
option(JAMI_PLUGIN "Build with plugin support" ON)
option(JAMI_NODEJS "Build the NODEJS binding" OFF)
option(JAMI_JNI "Build the JNI binding" OFF)
option(JAMI_DBUS "Build the DBUS binding" OFF)
option(JAMI_VIDEO "Build with video support" ON)
option(JAMI_VIDEO_ACCEL "Build video hardware acceleration support" ON)
option(BUILD_CONTRIB "Build contrib to CONTRIB_PATH" ON)
option(BUILD_EXTRA_TOOLS "Build extra tools" OFF)
option(ENABLE_ASAN "Enable address sanitization" OFF)
option(ENABLE_COVERAGE "Enable coverage (for tests)" OFF)

if(ENABLE_ASAN AND NOT MSVC)
  message(STATUS "Address sanitization enabled for daemon")
  # Add AddressSanitizer flags for both compiler and linker
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
endif()

if(ENABLE_COVERAGE)
    message(STATUS "Coverage analysis enabled for daemon")
    include(CMake/coverage.cmake)
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_FILE_OFFSET_BITS=64")

include(CTest)

if(JAMI_NODEJS)
    # Required for nodejs binding
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

if(NOT MSVC)
    ################################################################################
    # Contrib
    ################################################################################

    # Android target mapping for contrib
    if (ANDROID_ABI STREQUAL "x86")
        set(TARGET i686-linux-android)
    elseif (ANDROID_ABI STREQUAL "x86_64")
        set(TARGET x86_64-linux-android)
    elseif (ANDROID_ABI STREQUAL "arm64-v8a")
        set(TARGET aarch64-linux-android)
    elseif (ANDROID_ABI STREQUAL "armeabi-v7a")
        set(TARGET armv7a-linux-androideabi)
    else()
        set(TARGET ${CMAKE_LIBRARY_ARCHITECTURE})
        if (NOT TARGET)
            execute_process(COMMAND gcc -dumpmachine  COMMAND tr -d '\n' OUTPUT_VARIABLE TARGET)
        endif()
    endif()
    set(CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${TARGET})

    include(ProcessorCount)
    ProcessorCount(NPROC)
    if(NOT NPROC EQUAL 0)
        set(CONTRIB_BUILD_FLAGS -j${NPROC})
    endif()

    if (BUILD_EXTRA_TOOLS)
        set(ENV{PATH} "${CMAKE_CURRENT_SOURCE_DIR}/extras/tools/build/bin:$ENV{PATH}")
        execute_process(
            COMMAND ./bootstrap
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make ${CONTRIB_BUILD_FLAGS}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make .pkg-config
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make .gas
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
    endif()
    if (JAMI_JNI)
        # Generate swig binding
        add_custom_command(
            OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/jami_wrapper.cpp
            COMMAND env PACKAGEDIR=${JAMI_JNI_PACKAGEDIR} "./make-swig.sh"
            DEPENDS
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/make-swig.sh
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/jni_interface.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/callmanager.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/configurationmanager.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/conversation.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/managerimpl.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/data_view.i
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni
        )
    endif()
endif()

if (BUILD_CONTRIB)
    if (NOT MSVC)
        set(CONTRIB_BUILD_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/native-${TARGET})
        file(MAKE_DIRECTORY ${CONTRIB_BUILD_PATH})
        file(MAKE_DIRECTORY ${CONTRIB_PATH})

        if (ANDROID)
            # See https://developer.android.com/ndk/guides/other_build_systems
            set(ENV{ANDROID_NDK} ${ANDROID_NDK})
            set(ENV{ANDROID_ABI} ${ANDROID_ABI})
            set(ENV{ANDROID_API} ${ANDROID_PLATFORM})
            set(ENV{TOOLCHAIN} ${ANDROID_TOOLCHAIN_ROOT})
            set(ENV{TARGET} ${TARGET})
            set(ENV{API} ${ANDROID_PLATFORM_LEVEL})
            set(ENV{CC} $ENV{TOOLCHAIN}/bin/${TARGET}$ENV{API}-clang)
            set(ENV{CXX} $ENV{TOOLCHAIN}/bin/${TARGET}$ENV{API}-clang++)
            set(ENV{AS} "$ENV{CC} -c")
            set(ENV{AR} ${CMAKE_AR})
            set(ENV{RANLIB} ${CMAKE_RANLIB})
            set(ENV{STRIP} ${CMAKE_STRIP})
            set(ENV{LD} $ENV{TOOLCHAIN}/bin/ld)
        endif()

        file(LOCK ${CONTRIB_BUILD_PATH} DIRECTORY)
        message(STATUS "Building contrib for architectures: ${CMAKE_OSX_ARCHITECTURES} ${CMAKE_SYSTEM}")
        list(LENGTH CMAKE_OSX_ARCHITECTURES CMAKE_OSX_ARCHITECTURES_LENGTH)
        if (APPLE AND CMAKE_OSX_ARCHITECTURES_LENGTH GREATER 1)
            message(STATUS "Building for multiple architectures: ${CMAKE_OSX_ARCHITECTURES}")
            foreach(ARCH ${CMAKE_OSX_ARCHITECTURES})
                message(STATUS "Building for architecture: ${ARCH}")
                set(CC_TARGET ${ARCH}-apple-darwin${CMAKE_SYSTEM_VERSION})
                set(CC_CONTRIB_BUILD_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/native-${CC_TARGET})
                set(CC_CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${CC_TARGET})
                file(MAKE_DIRECTORY ${CC_CONTRIB_BUILD_PATH})
                file(MAKE_DIRECTORY ${CC_CONTRIB_PATH})
                set(BOOTSTRAP_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/contrib/bootstrap --host=${CC_TARGET})
                if (IGNORE_SYSTEM_LIBS)
                    list(APPEND BOOTSTRAP_COMMAND --ignore-system-libs)
                endif()
                execute_process(
                    COMMAND env CMAKE_OSX_ARCHITECTURES=${ARCH} ${BOOTSTRAP_COMMAND}
                    WORKING_DIRECTORY ${CC_CONTRIB_BUILD_PATH})
                execute_process(COMMAND env CMAKE_OSX_ARCHITECTURES=${ARCH} make list
                    WORKING_DIRECTORY ${CC_CONTRIB_BUILD_PATH})
                execute_process(COMMAND env CMAKE_OSX_ARCHITECTURES=${ARCH} make ${CONTRIB_BUILD_FLAGS}
                    WORKING_DIRECTORY ${CC_CONTRIB_BUILD_PATH})
            endforeach()
            # Build fat contrib: merge all .a files
            set(FAT_CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/apple-darwin${CMAKE_SYSTEM_VERSION})
            execute_process(COMMAND rm -rf ${FAT_CONTRIB_PATH})
            list(GET CMAKE_OSX_ARCHITECTURES 0 ARCH_FIRST)
            set(CONTRIB_PATH_FIRST ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${ARCH_FIRST}-apple-darwin${CMAKE_SYSTEM_VERSION})
            string(REPLACE "arm64" "aarch64" ARCH_FIRST_LIB ${ARCH_FIRST})
            set(TARGET_FIRST_LIB ${ARCH_FIRST_LIB}-apple-darwin${CMAKE_SYSTEM_VERSION})
            execute_process(COMMAND cp -r ${CONTRIB_PATH_FIRST} ${FAT_CONTRIB_PATH})
            file(GLOB_RECURSE LIB_FILES ${FAT_CONTRIB_PATH}/lib/*.a)
            foreach(LIB_FILE_PATH ${LIB_FILES})
                get_filename_component(LIB_FILE ${LIB_FILE_PATH} NAME)
                get_filename_component(LIB_FILE_NAME ${LIB_FILE_PATH} NAME_WLE)
                set(LIB_FILES_TO_MERGE "-create")
                foreach(ARCH ${CMAKE_OSX_ARCHITECTURES})
                    string(REPLACE "arm64" "aarch64" ARCH_LIB ${ARCH})
                    set(CC_TARGET ${ARCH}-apple-darwin${CMAKE_SYSTEM_VERSION})
                    set(CC_CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${CC_TARGET})
                    string(REPLACE ${TARGET_FIRST_LIB} ${ARCH_LIB}-apple-darwin${CMAKE_SYSTEM_VERSION} CC_LIB_FILE_NAME ${LIB_FILE})
                    set(CC_LIB_FILE_PATH "${CC_CONTRIB_PATH}/lib/${CC_LIB_FILE_NAME}")
                    if(NOT EXISTS ${CC_LIB_FILE_PATH})
                        message(FATAL_ERROR "Required library file not found: ${CC_LIB_FILE_PATH}")
                    endif()
                    list(APPEND LIB_FILES_TO_MERGE ${CC_LIB_FILE_PATH})
                endforeach()
                list(APPEND LIB_FILES_TO_MERGE "-output" "${FAT_CONTRIB_PATH}/lib/${LIB_FILE}")
                execute_process(COMMAND lipo ${LIB_FILES_TO_MERGE})
            endforeach()
            # replace all path references in pc and cmake files
            file(GLOB_RECURSE PC_FILES ${FAT_CONTRIB_PATH}/lib/pkgconfig/*.pc)
            file(GLOB_RECURSE CMAKE_FILES ${FAT_CONTRIB_PATH}/lib/cmake/*.cmake)
            list(APPEND ALL_FILES ${PC_FILES} ${CMAKE_FILES})
            foreach(FILE_PATH ${ALL_FILES})
                file(READ ${FILE_PATH} PC_FILE_CONTENT)
                string(REPLACE ${CONTRIB_PATH_FIRST} ${FAT_CONTRIB_PATH} PC_FILE_CONTENT ${PC_FILE_CONTENT})
                file(WRITE ${FILE_PATH} ${PC_FILE_CONTENT})
            endforeach()
            set(CONTRIB_PATH ${FAT_CONTRIB_PATH})
        else()
            message(STATUS "Building contrib for ${TARGET}")
            set(BOOTSTRAP_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/contrib/bootstrap --host=${TARGET})
            if (IGNORE_SYSTEM_LIBS)
                list(APPEND BOOTSTRAP_COMMAND --ignore-system-libs)
            endif()
            execute_process(
                COMMAND ${BOOTSTRAP_COMMAND}
                WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
            execute_process(COMMAND make list
                WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
            execute_process(COMMAND make ${CONTRIB_BUILD_FLAGS}
                WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
        endif()
        file(LOCK ${CONTRIB_BUILD_PATH} DIRECTORY RELEASE)
    else()
        set(SCRIPTS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/extras/scripts)
        execute_process(
            COMMAND python ${SCRIPTS_DIR}/winmake.py
            WORKING_DIRECTORY ${SCRIPTS_DIR}
            RESULT_VARIABLE BUILD_RESULT
        )
        if (BUILD_RESULT)
            message(FATAL_ERROR "Contrib build failed.")
        else()
            message(STATUS "Contrib build successful.")
        endif()
    endif()
endif()

################################################################################
# Check dependencies
################################################################################

if(NOT MSVC)
    include(FindPkgConfig)
    if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
        pkg_search_module (udev REQUIRED IMPORTED_TARGET libudev)
        pkg_search_module (pulseaudio IMPORTED_TARGET libpulse)
        pkg_search_module (alsa IMPORTED_TARGET alsa)
        pkg_search_module (jack IMPORTED_TARGET libjack)

        # Make sure at least one audio backend is available
        if(NOT pulseaudio_FOUND AND NOT alsa_FOUND AND NOT jack_FOUND)
            message(FATAL_ERROR "No audio library found. Please install PulseAudio, ALSA or JACK.")
        endif()
    endif()
endif()

################################################################################
# Source groups
################################################################################

# compat, src source group
if(MSVC)
    add_subdirectory("compat")
endif()

add_subdirectory("src")
source_group("Source Files" FILES ${Source_Files})
source_group("Source Files\\client" FILES ${Source_Files__client})
source_group("Source Files\\config" FILES ${Source_Files__config})
source_group("Source Files\\connectivity" FILES ${Source_Files__connectivity})
source_group("Source Files\\connectivity\\security" FILES ${Source_Files__security})
source_group("Source Files\\connectivity\\sip" FILES ${Source_Files__sip})

=== python/CMakeLists.txt ===
set(CURRENT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

configure_file(setup.py.in setup.py)
configure_file(pyproject.toml pyproject.toml COPYONLY)
configure_file(README.md README.md COPYONLY)

find_package(Python3 REQUIRED COMPONENTS Interpreter)

add_custom_target(python
    COMMAND ${Python3_EXECUTABLE} -m build "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS opendht opendht_cpp.pxd opendht.pyx pyproject.toml
            ${CURRENT_SOURCE_DIR}/opendht/__init__.py
            ${CURRENT_SOURCE_DIR}/opendht/aio.py)

install(CODE [[
    execute_process(
        COMMAND "${Python3_EXECUTABLE}" -m pip install --no-deps --break-system-packages "${CMAKE_CURRENT_BINARY_DIR}"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        OUTPUT_VARIABLE _pip_output
        ERROR_VARIABLE _pip_output
        RESULT_VARIABLE _pip_result)
    message(STATUS ${_pip_output})
    if(NOT _pip_result EQUAL 0)
        message(FATAL_ERROR "pip install failed with code ${_pip_result}")
    endif()
]])
if (OPENDHT_TOOLS)
	install(PROGRAMS tools/dhtcluster.py DESTINATION ${CMAKE_INSTALL_BINDIR} RENAME dhtcluster)
endif()

=== test/CMakeLists.txt ===
find_package(Threads REQUIRED)

set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
set(BUILD_MOCK ON CACHE BOOL "" FORCE)
set(INSTALL_GTEST OFF CACHE BOOL "" FORCE)
set(CMAKE_POLICY_DEFAULT_CMP0048 NEW)

if(YAML_USE_SYSTEM_GTEST)
  find_package(GTest)
  if (NOT GTEST_FOUND)
    message(FATAL_ERROR "system googletest was requested but not found")
  endif()
else()
    add_subdirectory(
      "${CMAKE_CURRENT_SOURCE_DIR}/gtest-1.11.0"
      "${CMAKE_CURRENT_BINARY_DIR}/prefix")
    include_directories(SYSTEM "${CMAKE_CURRENT_SOURCE_DIR}/gtest-1.11.0/googletest/include")
endif()

set(test-new-api-pattern "new-api/*.cpp")
set(test-source-pattern "*.cpp" "integration/*.cpp" "node/*.cpp")
if (CMAKE_VERSION VERSION_GREATER 3.11)
  list(INSERT test-new-api-pattern 0 CONFIGURE_DEPENDS)
  list(INSERT test-source-pattern 0 CONFIGURE_DEPENDS)
endif()

file(GLOB test-new-api-sources ${test-new-api-pattern})
file(GLOB test-sources ${test-source-pattern})

add_executable(yaml-cpp-tests "")
target_sources(yaml-cpp-tests
  PRIVATE
    ${test-new-api-sources}
    ${test-sources})
target_include_directories(yaml-cpp-tests
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/integration
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/src)
target_compile_options(yaml-cpp-tests
  PRIVATE
    $<$<CXX_COMPILER_ID:Clang>:-Wno-c99-extensions -Wno-variadic-macros -Wno-sign-compare>
    $<$<CXX_COMPILER_ID:GNU>:-Wno-variadic-macros -Wno-sign-compare -Wno-narrowing>)
target_link_libraries(yaml-cpp-tests
  PRIVATE
    Threads::Threads
    yaml-cpp
    gtest
    gmock)

set_property(TARGET yaml-cpp-tests PROPERTY CXX_STANDARD_REQUIRED ON)
if (NOT DEFINED CMAKE_CXX_STANDARD)
  set_target_properties(yaml-cpp-tests PROPERTIES CXX_STANDARD 11)
endif()


add_test(NAME yaml-cpp::test COMMAND yaml-cpp-tests)

if (build-windows-dll)
  add_custom_command(
    TARGET yaml-cpp-tests
    POST_BUILD COMMAND ${CMAKE_COMMAND} -E
    copy_if_different "$<TARGET_FILE:yaml-cpp>" "$<TARGET_FILE_DIR:yaml-cpp-tests>")
endif()

=== tools/CMakeLists.txt ===
if (MSVC)
    set (MSC_COMPAT_DIR ../src/compat/win32)
    set (MSC_COMPAT_SOURCES ${MSC_COMPAT_DIR}/wingetopt.c)
    set (MSVC_COMPAT_DIR ../src/compat/msvc)
endif()

function (configure_tool name extra_files)
    add_executable (${name} ${name}.cpp ${extra_files})
    add_dependencies(${name} opendht)
    if (MSVC)
        target_sources(${name} PRIVATE ${MSC_COMPAT_SOURCES})
        target_link_libraries (${name} PUBLIC opendht)
        target_include_directories (${name} PRIVATE SYSTEM ${MSC_COMPAT_DIR} ${MSVC_COMPAT_DIR})
    else()
        target_link_libraries (${name} LINK_PUBLIC opendht ${READLINE_LIBRARIES})
        target_include_directories (${name} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
    endif ()
endfunction ()

configure_tool (dhtnode tools_common.h)
if (OPENDHT_EXAMPLES)
    configure_tool (dhtscanner tools_common.h)
    configure_tool (dhtchat tools_common.h)
endif ()
if (NOT MSVC)
    configure_tool (perftest tools_common.h)
endif ()
if (OPENDHT_HTTP)
    configure_tool (durl tools_common.h)
endif ()

if (OPENDHT_C)
    add_executable (dhtcnode dhtcnode.c)
    add_dependencies(dhtcnode opendht-c)
    target_link_libraries (dhtcnode PUBLIC opendht-c)
    target_include_directories (dhtcnode SYSTEM PRIVATE ${PROJECT_SOURCE_DIR}/c)
    if (WIN32)
        target_link_libraries (dhtcnode PUBLIC ws2_32)
    endif()
    if (MSVC)
        target_sources(dhtcnode PRIVATE ${MSC_COMPAT_SOURCES})
        target_link_libraries(dhtcnode PRIVATE unofficial::readline-win32::readline)
        target_include_directories (dhtcnode SYSTEM PRIVATE ${MSC_COMPAT_DIR} ${MSVC_COMPAT_DIR})
    endif()
endif ()

if (NOT DEFINED CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR bin)
endif ()

install (TARGETS dhtnode RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
if (OPENDHT_EXAMPLES)
    install (TARGETS dhtscanner dhtchat RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif ()
if(MSVC)
    install(FILES $<TARGET_PDB_FILE:dhtnode> CONFIGURATIONS "Debug" "RelWithDebInfo" DESTINATION ${CMAKE_INSTALL_BINDIR})
    if (OPENDHT_EXAMPLES)
        install(FILES $<TARGET_PDB_FILE:dhtscanner> $<TARGET_PDB_FILE:dhtchat> CONFIGURATIONS "Debug" "RelWithDebInfo" DESTINATION ${CMAKE_INSTALL_BINDIR})
    endif()
endif()

if (OPENDHT_SYSTEMD)
    if (NOT DEFINED OPENDHT_SYSTEMD_UNIT_FILE_LOCATION OR NOT OPENDHT_SYSTEMD_UNIT_FILE_LOCATION)
        execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} systemd --variable=systemdsystemunitdir
                        OUTPUT_VARIABLE SYSTEMD_UNIT_INSTALL_DIR)
        message("-- Using Systemd unit installation directory by pkg-config: " ${SYSTEMD_UNIT_INSTALL_DIR})
    else()
        message("-- Using Systemd unit installation directory requested: " ${OPENDHT_SYSTEMD_UNIT_FILE_LOCATION})
        set(SYSTEMD_UNIT_INSTALL_DIR ${OPENDHT_SYSTEMD_UNIT_FILE_LOCATION})
    endif()

    configure_file (
        systemd/dhtnode.service.in
        systemd/dhtnode.service
        @ONLY
    )
    if (SYSTEMD_UNIT_INSTALL_DIR)
        string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_UNIT_INSTALL_DIR "${SYSTEMD_UNIT_INSTALL_DIR}")
        set (systemdunitdir "${SYSTEMD_UNIT_INSTALL_DIR}")
        install (FILES ${CMAKE_CURRENT_BINARY_DIR}/systemd/dhtnode.service DESTINATION ${systemdunitdir})
        install (FILES systemd/dhtnode.conf DESTINATION ${sysconfdir})
    else()
        message(WARNING "Systemd unit installation directory not found. The systemd unit won't be installed.")
    endif()

    if (OPENDHT_PYTHON)
        configure_file (
            systemd/dhtcluster.service.in
            systemd/dhtcluster.service
            @ONLY
        )
        if (SYSTEMD_UNIT_INSTALL_DIR)
            install (FILES ${CMAKE_CURRENT_BINARY_DIR}/systemd/dhtcluster.service DESTINATION ${systemdunitdir})
            install (FILES systemd/dhtcluster.conf DESTINATION ${sysconfdir})
        endif()
    endif()
endif ()

=== dev/restinio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

if(NOT RESTINIO_LIBRARY_NAME)
    # That must be the case when RESTinio is used as a dependency.
    set(RESTINIO_LIBRARY_NAME restinio)
endif()

# ====================================================================
# Version
include(${CMAKE_CURRENT_SOURCE_DIR}/version.cmake)
message(STATUS "RESTINIO_VERSION: ${RESTINIO_VERSION}")
# ====================================================================

project(${RESTINIO_LIBRARY_NAME}
        VERSION ${RESTINIO_VERSION}
        LANGUAGES CXX)

# ====================================================================
# RESTinio target and it's attributes
# ====================================================================

add_library(${RESTINIO_LIBRARY_NAME} INTERFACE)
add_library(${RESTINIO_LIBRARY_NAME}::${RESTINIO_LIBRARY_NAME} ALIAS ${RESTINIO_LIBRARY_NAME})

target_include_directories(
    ${RESTINIO_LIBRARY_NAME} INTERFACE
    # TODO: that might be a good idea to move
    #       headers to include dir so the next dir is not pointing to
    #       the parent dir.
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/..>
    $<INSTALL_INTERFACE:include>)

if (RESTINIO_EXPLICIT_CPPSTD)
    if ("${RESTINIO_EXPLICIT_CPPSTD}" STREQUAL "17" )
        target_compile_features(${RESTINIO_LIBRARY_NAME} INTERFACE cxx_std_17)
    elseif ("${RESTINIO_EXPLICIT_CPPSTD}" STREQUAL "20")
        target_compile_features(${RESTINIO_LIBRARY_NAME} INTERFACE cxx_std_20)
    elseif ("${RESTINIO_EXPLICIT_CPPSTD}" STREQUAL "23")
        target_compile_features(${RESTINIO_LIBRARY_NAME} INTERFACE cxx_std_23)
    else ()
        message(FATAL_ERROR
                "invalid RESTINIO_EXPLICIT_CPPSTD (value ='${RESTINIO_EXPLICIT_CPPSTD}')"
                "must be on of: [17, 20, 23]")
    endif ()
endif()

# --------------------------------------------------------------------
# Handle ASIO dependency.
if (RESTINIO_ASIO_SOURCE STREQUAL "standalone")
    if (RESTINIO_DEP_STANDALONE_ASIO STREQUAL "system")
        message(STATUS "${RESTINIO_LIBRARY_NAME} target assumes standalone asio is available in system headers")
    elseif (TARGET asio::asio)
        target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE asio::asio)
        message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'asio::asio' target")
    elseif (asio_INCLUDE_DIRS)
        target_include_directories(${RESTINIO_LIBRARY_NAME} INTERFACE ${asio_INCLUDE_DIRS})
        message(STATUS "${RESTINIO_LIBRARY_NAME} target will use asio_INCLUDE_DIRS include dirs: ${asio_INCLUDE_DIRS}")
    else ()
        message(FATAL_ERROR
                "Unable to identify how to depend on standalone ASIO "
                "Giving up...")
    endif()
elseif (RESTINIO_ASIO_SOURCE STREQUAL "boost")
    if (RESTINIO_DEP_BOOST_ASIO STREQUAL "system")
        message(STATUS "${RESTINIO_LIBRARY_NAME} target assumes Boost::asio is available in system headers")
    elseif (TARGET Boost::headers)
        target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE Boost::headers)
        message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'Boost::headers' target")
    elseif (TARGET Boost::asio)
        target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE Boost::asio)
        message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'Boost::asio' target")
    elseif (Boost_INCLUDE_DIRS)
        target_include_directories(${RESTINIO_LIBRARY_NAME} INTERFACE ${Boost_INCLUDE_DIRS})
        message(STATUS "${RESTINIO_LIBRARY_NAME} target will use Boost_INCLUDE_DIRS include dirs: ${Boost_INCLUDE_DIRS}")
    else ()
        message(FATAL_ERROR
                "Unable to identify how to depend on Boost::asio. "
                "Giving up...")
    endif ()

    target_compile_definitions(${RESTINIO_LIBRARY_NAME} INTERFACE RESTINIO_USE_BOOST_ASIO)
else ()
    message(FATAL_ERROR "Invalid value for RESTINIO_ASIO_SOURCE (${RESTINIO_ASIO_SOURCE})")
endif ()
# --------------------------------------------------------------------

# --------------------------------------------------------------------
# Handle LLHTTP dependency.
if (RESTINIO_DEP_LLHTTP STREQUAL "system")
    message(STATUS "Using system llhttp")
    if (RESTINIO_LLHTTP_LIB_LINK_NAME)
        message(STATUS "Using system llhttp with linking to custom lib name: ${RESTINIO_LLHTTP_LIB_LINK_NAME}")
        target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE ${RESTINIO_LLHTTP_LIB_LINK_NAME})
    else()
        target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE llhttp)
    endif()
elseif (TARGET llhttp::llhttp)
    target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE llhttp::llhttp)
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'llhttp::llhttp' target")
elseif (TARGET llhttp::llhttp_static)
    target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE llhttp::llhttp_static)
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'llhttp::llhttp_static' target")
elseif (TARGET llhttp::llhttp_dynamic)
    target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE llhttp::llhttp_dynamic)
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'llhttp::llhttp_dynamic' target")
else ()
    message(FATAL_ERROR
            "Unable to identify how to depend on llhttp. "
            "Giving up...")
endif()
# --------------------------------------------------------------------

# --------------------------------------------------------------------
# Handle FMT dependency.
if (RESTINIO_DEP_FMT STREQUAL "system")
    if (RESTINIO_FMT_LIB_LINK_NAME)
        message(STATUS "Using system fmt with linking to ${RESTINIO_FMT_LIB_LINK_NAME}")
        # target_compile_definitions(${RESTINIO_LIBRARY_NAME} INTERFACE FMT_HEADER_ONLY=0 )
        target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE ${RESTINIO_FMT_LIB_LINK_NAME})
    else()
        message(STATUS "Using system fmt (assume header-only)")
        target_compile_definitions(${RESTINIO_LIBRARY_NAME} INTERFACE FMT_HEADER_ONLY=1 )
    endif()
elseif (NOT "${RESTINIO_FMT_TARGET}" STREQUAL "" )
    target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE ${RESTINIO_FMT_TARGET})
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on '${RESTINIO_FMT_TARGET}' target")
elseif (TARGET fmt::fmt)
    target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE fmt::fmt)
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'fmt::fmt' target")
else ()
    message(FATAL_ERROR
            "Unable to identify how to depend on FMT. "
            "Giving up...")
endif()
# --------------------------------------------------------------------

# --------------------------------------------------------------------
# Handle expected lite dependency.
if ("${RESTINIO_EXPLICIT_CPPSTD}" STREQUAL "17"
    OR "${RESTINIO_EXPLICIT_CPPSTD}" STREQUAL "20"
    OR "CMAKE_CXX_STANDARD" STREQUAL "17"
    OR "CMAKE_CXX_STANDARD" STREQUAL "20")

    # TODO: Consider expected that comes with C++23.
    #       In that case the next fragment must be places under a given
    #       conditional block.
endif()

if (RESTINIO_DEP_EXPECTED_LITE STREQUAL "system")
    message(STATUS "Using system expected-lite")
elseif (TARGET expected-lite::expected-lite)
    target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE expected-lite::expected-lite)
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'nonstd::expected-lite' target")
elseif (TARGET nonstd::expected-lite)
    target_link_libraries(${RESTINIO_LIBRARY_NAME} INTERFACE nonstd::expected-lite)
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will depend on 'nonstd::expected-lite' target")
elseif (nonstd_expected-lite_INCLUDE_DIRS)
    target_include_directories(${RESTINIO_LIBRARY_NAME} INTERFACE ${nonstd_expected-lite_INCLUDE_DIRS})
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will use nonstd_expected-lite_INCLUDE_DIRS include dirs: ${nonstd_expected-lite_INCLUDE_DIRS}")
elseif (nonstd_INCLUDE_DIRS)
    target_include_directories(${RESTINIO_LIBRARY_NAME} INTERFACE ${nonstd_INCLUDE_DIRS})
    message(STATUS "${RESTINIO_LIBRARY_NAME} target will use nonstd_INCLUDE_DIRS include dirs: ${nonstd_INCLUDE_DIRS}")
else ()
    message(FATAL_ERROR
            "Unable to identify how to depend on nonstd::expected-lite. "
            "Giving up...")
endif()
# --------------------------------------------------------------------


if (RESTINIO_INSTALL)
    include(GNUInstallDirs)
    include(CMakePackageConfigHelpers)

  set(RESTINIO_CMAKE_INSTALL_DEST_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/restinio CACHE STRING
      "Installation directory for cmake files, relative to ${CMAKE_INSTALL_PREFIX}.")

  set(restinio_version_config_tmp_file ${PROJECT_BINARY_DIR}/restinio-config-version.cmake)
  set(restinio_project_config_tmp_file ${PROJECT_BINARY_DIR}/restinio-config.cmake)

  SET(restinio_install_include_dir ${CMAKE_INSTALL_INCLUDEDIR}/restinio/ CACHE STRING
      "Installation directory for include files, relative to ${CMAKE_INSTALL_PREFIX}.")

  # Generate the version, config and target files into the build directory.
  write_basic_package_version_file(
      ${restinio_version_config_tmp_file}
      VERSION ${RESTINIO_VERSION}
      COMPATIBILITY SameMinorVersion )

  configure_package_config_file(
      "cmake/restinio-config.cmake.in"
      ${restinio_project_config_tmp_file}
      INSTALL_DESTINATION ${RESTINIO_CMAKE_INSTALL_DEST_DIR}
      PATH_VARS RESTINIO_VERSION)

    # Install version, config and target files.
    install(
        FILES ${restinio_project_config_tmp_file} ${restinio_version_config_tmp_file}
        DESTINATION ${RESTINIO_CMAKE_INSTALL_DEST_DIR})

    SET(RESTINIO_INSTALL_TARGETS ${RESTINIO_LIBRARY_NAME})

    install(
        TARGETS ${RESTINIO_INSTALL_TARGETS}
        EXPORT RESTINIO_ALL_TARGETS
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION bin
    )

    install(
        EXPORT RESTINIO_ALL_TARGETS
        NAMESPACE restinio::
        FILE restinio-targets.cmake
        DESTINATION ${RESTINIO_CMAKE_INSTALL_DEST_DIR} )

    file(GLOB_RECURSE RESTINIO_HEADERS_ALL RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.?pp)
    foreach (HEADER_FILE ${RESTINIO_HEADERS_ALL} )
      get_filename_component( DIR ${HEADER_FILE} PATH )
      install( FILES ${HEADER_FILE} DESTINATION ${restinio_install_include_dir}/${DIR} )
    endforeach ()
endif ()

=== dev/sample/CMakeLists.txt ===
project(${RESTINIO_LIBRARY_NAME}_sample)

add_subdirectory(hello_world_basic)
add_subdirectory(hello_world)
add_subdirectory(hello_world_minimal)
add_subdirectory(hello_world_delayed)
add_subdirectory(hello_world_sendfile)
add_subdirectory(run_existing_server)
add_subdirectory(run_for_minute)
add_subdirectory(express_router)
add_subdirectory(express_router_tutorial)
add_subdirectory(easy_parser_router)
add_subdirectory(sendfiles)
add_subdirectory(query_string_params)
add_subdirectory(try_parse_query_string)
add_subdirectory(websocket)
add_subdirectory(websocket_detailed)
add_subdirectory(using_external_io_context)

if ( RESTINIO_WITH_SOBJECTIZER )
	add_subdirectory(async_handling_with_sobjectizer)
	add_subdirectory(async_chained_handlers)
endif()

if (ZLIB_FOUND)
	add_subdirectory(compression)
	add_subdirectory(decompression)
endif ()

if ( RESTINIO_WITH_SOBJECTIZER )
	add_subdirectory(notificators)
endif()

add_subdirectory(custom_buffer)
add_subdirectory(connection_state)
add_subdirectory(ip_blocker)
add_subdirectory(file_upload)

add_subdirectory(chained_handlers)
add_subdirectory(extra_data_factory)

if ( OPENSSL_FOUND )
	add_subdirectory(hello_world_https)
	add_subdirectory(shared_tls_context)
	add_subdirectory(hello_world_sendfile_https)
	add_subdirectory(websocket_wss)
	add_subdirectory(tls_inspector)
endif ()

if( WIN32 )
	add_subdirectory(hello_world_sendfile_w32_unicode)
endif()

=== libavfilter/dnn/Makefile ===
OBJS-$(CONFIG_DNN)                           += dnn/dnn_interface.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_io_proc.o
OBJS-$(CONFIG_DNN)                           += dnn/queue.o
OBJS-$(CONFIG_DNN)                           += dnn/safe_queue.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_common.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layers.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_avgpool.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_dense.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_pad.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_conv2d.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_depth2space.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_maximum.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_mathbinary.o
OBJS-$(CONFIG_DNN)                           += dnn/dnn_backend_native_layer_mathunary.o

DNN-OBJS-$(CONFIG_LIBTENSORFLOW)             += dnn/dnn_backend_tf.o
DNN-OBJS-$(CONFIG_LIBOPENVINO)               += dnn/dnn_backend_openvino.o

OBJS-$(CONFIG_DNN)                           += $(DNN-OBJS-yes)

=== dev/benches/single_handler/CMakeLists.txt ===
set(BENCH _bench.restinio.single_handler)
include(${CMAKE_SOURCE_DIR}/cmake/bench.cmake)

target_link_libraries(${BENCH} PRIVATE restinio_helpers::cmd_line_args)

=== dev/benches/single_handler_no_timer/CMakeLists.txt ===
set(BENCH _bench.restinio.single_handler_no_timer)
include(${CMAKE_SOURCE_DIR}/cmake/bench.cmake)

target_link_libraries(${BENCH} PRIVATE restinio_helpers::cmd_line_args)

=== dev/sample/async_chained_handlers/CMakeLists.txt ===
set(SAMPLE sample.async_chained_handlers)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)

if (RESTINIO_DEP_SOBJECTIZER STREQUAL "system")
	target_compile_definitions(${SAMPLE} PRIVATE SO_5_STATIC_LIB)
endif()

target_link_libraries(${SAMPLE} PRIVATE ${RESTINIO_SOBJECTIZER_LIB_LINK_NAME})

=== dev/sample/express_router/CMakeLists.txt ===
set(SAMPLE sample.express_router)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)

=== extras/packaging/gnu-linux/rules/debian/control ===
Source: jami
Section: comm
Priority: optional
Maintainer: The Jami project <jami@gnu.org>
Build-Depends: debhelper (>= 9),
               autoconf,
               automake,
               libtool,
               autotools-dev,
# qt client
               libqt-jami,
               python3,
               libnm-dev,
               libnotify-dev,
               libqrencode-dev,
               libayatana-appindicator3-dev | libappindicator3-dev,
# daemon
               libdbus-1-dev,
               libsystemd-dev,
               libupnp-dev,
               libgnutls28-dev,
               libpulse-dev,
               libasound2-dev,
               libexpat1-dev,
               libpcre3-dev | libpcre2-dev,
               libyaml-cpp-dev,
               libboost-dev,
               libxext-dev,
               libxfixes-dev,
               libspeex-dev,
               libspeexdsp-dev,
               uuid-dev,
               libavcodec-dev | libavcodec-extra-dev,
               libavutil-dev,
               libavformat-dev,
               libswscale-dev,
               libavdevice-dev,
               libopus-dev,
               libudev-dev,
               libgsm1-dev,
               libjsoncpp-dev,
               libnatpmp-dev,
               libva-dev,
               libcrypto++-dev,
               libvdpau-dev,
               libssl-dev,
               libargon2-dev | libargon2-0-dev,
               libpipewire-0.3-dev,
# other
               nasm,
               yasm,
Standards-Version: 4.1.5
Homepage: https://jami.net
Vcs-Git: https://git.jami.net/savoirfairelinux/jami-client-qt.git
Vcs-Browser: https://git.jami.net/savoirfairelinux/jami-client-qt

# The jami-all package is used as the "one-click install" package
# offered on the Jami website.  The following relationships ensure
# that installing the jami-all package replaces version of the other
# individual Jami packages.  This is so that users can fix any
# installation problem on their side by simply reinstalling as per the
# website instructions.
#
Package: jami-all
Architecture: any
Depends: gnupg,
         ${shlibs:Depends},
         ${misc:Depends}
Replaces: jami,
          jami-libclient,
          jami-daemon,
          libqt-jami (>= 6.6.1),
Conflicts: jami,
           jami-libclient,
           jami-libclient-gnome,
           jami-daemon,
           jami-gnome,
           libqt-jami
Description: One-click install package for Jami
 This package only exists to provide an easy installation user experience.
 To install the default client, install the 'jami' package.

Package: jami
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         jami-daemon (=${binary:Version}),
         libqt-jami (>= 6.6.1)
Provides: jami-qt
Replaces: jami-all,
          jami-libclient (<= 20220516.0214.9b42ad3~dfsg1-1)
Breaks: jami-libclient (<= 20220516.0214.9b42ad3~dfsg1-1)
Conflicts: jami-all
Description: Secure and distributed voice, video and chat platform - desktop client
 Jami (jami.net) is a secure and distributed voice, video and chat communication
 platform that requires no centralized server and leaves the power of privacy
 in the hands of the user.
 .
 This package contains the jami-qt desktop client.

# Made into a transitional package on 2022-06-21, after libjamiclient
# was merged into src/libclient under jami-client-qt.git, to provide
# an upgrade path to existing users.  Feel free to remove this package
# later into the future, some time after 2023-06-21 perhaps.
Package: jami-libclient
Architecture: any
Description: transitional package for jami
 This is a transitional package. Jami libclient has been merged into
 the jami-qt client code-base, and this package can be safely removed.

Package: jami-daemon
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Secure and distributed voice, video and chat platform - daemon
 Jami (jami.net) is a secure and distributed voice, video and chat communication
 platform that requires no centralized server and leaves the power of privacy
 in the hands of the user.
 .
 This package contains the Jami daemon: jamid.
